import java.io.*;

public class ASCIIDataField extends AbstractDataField {

int nbytes;
String string;


public ASCIIDataField(String name, int size, String comment) {

super(name,size,comment);

nbytes=size/8;

min_value=null;
max_value=null;

} // end of constructor

/**********************************************************************
* method to read this data field 
**********************************************************************/
public void read(BitInputStream in) throws IOException {

//System.out.println("about to read "+nbytes+" byte string "+
//                   in.available()+" available");
byte[] bytes = new byte[nbytes];
in.readFully(bytes);
string = new String(bytes,"ASCII");

//System.out.println("read "+string+" length="+string.length() );

} // end of read method



/**********************************************************************
* method to write this data field 
**********************************************************************/
public void write(BitOutputStream out) throws IOException {

byte[] bytes = string.getBytes("ASCII");
out.write(bytes,0, bytes.length);

} // end of write method


public boolean isInValidRange(Number n) { return true; }

/**********************************************************************
* handy string representation 
**********************************************************************/
public String toString() {

return name+" = "+string+" / "+comment; 

}

public String formattedValue() { return string; }

/**********************************************************************
* return a Number of the appropriate type for this field
* returns null if the data type of this field is unknown or weird.
**********************************************************************/
public Number validateType(Number n) { return n; }



} // end of ASCIIDataField class
