import java.io.*;
import java.awt.*;
import javax.swing.*;


public abstract class CompositeDataField extends DataBlock 
                                         implements DataField {

protected String name;
protected String comment;

/***********************************************************************
* 
***********************************************************************/
public CompositeDataField(String type) throws IOException { super(type); }




/**********************************************************************
* accessors 
**********************************************************************/
public String name(           ) {      return name; }
public void   name(String name) { this.name = name; }


public String comment(              ) {         return comment; }
public void   comment(String comment) { this.comment = comment; }

public String formattedValue() {

    Number value = value();
    if(value == null) return null;
    return value.toString(); 
}

public void minValue(Number min) {}
public void maxValue(Number max) {}

/*****************************************************************************
* string representation
*****************************************************************************/
public String toString() {

return  name+" = "
       +formattedValue() +" / "
       +comment; 

} 

/**********************************************************************
* component for rendering 
**********************************************************************/
public Component displayComponent(boolean selected, boolean expanded, 
                                  int row, boolean hasFocus) {

    return new DataFieldRenderer(this);

} // end of displayComponent method



/***************************************************************************
* editing methods 
***************************************************************************/
public DataNodeEditor getEditor(int row) {

    return new DataFieldRenderer(this,true);

}

/***************************************************************************
* allow a new value to be set  - called by tree after editing
***************************************************************************/
public void setUserObject(Object o) { 

try {
    value(new Double(o.toString() ));
    return;
} catch (NumberFormatException e) {}

} // end of setUserObject method



} // end of CompositeDataField
