import java.util.*;
import java.io.*;

public class Config {

/***************************************************************************
* main method  
***************************************************************************/
public static void main(String[] args) throws Exception {

if(args.length==0) System.exit(0);

/***********************************
* create the properties object *
*******************************/
Properties param = new Properties();

File file=null;
if(args[0].indexOf('=') == -1 ) {
    /********************************
    * first argument is a file name *
    ********************************/
    file = new File(args[0]);
}

/**********************************************
* if the first argument is a file name then 
* read the properties from that file
**********************************************/
if(file != null) {
    new FileInputStream(file);
    param.load(new FileInputStream(file) );
}


/****************************************************************
* read the rest of the arguments, parse them as key=value pairs
* and add them to the properties
****************************************************************/
for(int i=0; i<args.length; ++i) {

    int index = args[i].indexOf('=');
    if(index != -1) {

        param.setProperty(args[i].substring(0,index),
                          args[i].substring(index+1)    );
    }
 

} // end of loop over arguments


/******************************************************************
* now write the properties to stdout or back to the original file *
******************************************************************/
OutputStream out;
if(file==null) out = System.out;
else           out = new FileOutputStream(file);

param.store(out,null);

} // end of main


} // end of config class
