import java.io.*;

public class DoubleField extends AbstractDataField {

/**********************************************************************
* constructor 
**********************************************************************/
DoubleField() { this(null,null); }
DoubleField(String name, String comment) {

super(name,64,comment);

/*********************
* min and max values *
*********************/
min_value=null;
max_value=null;

} // end of constructor

/**********************************************************************
* size can't be changed 
**********************************************************************/
public void size(int size) { }



/**********************************************************************
* check if a given Number is a valid value for this field 
**********************************************************************/
public boolean isInValidRange(Number n) {

if(min_value!=null && n.doubleValue() < min_value.doubleValue() ) return false;
if(max_value!=null && n.doubleValue() > max_value.doubleValue() ) return false;

return true;

} // end of isInValidRange method

/**********************************************************************
* return a Number of the appropriate type for this field
* returns null if the data type of this field is unknown or weird.
**********************************************************************/
public Number validateType(Number n) { return new Double(n.doubleValue() ); }

/**********************************************************************
* method to read this data field 
**********************************************************************/
public void read(BitInputStream in) throws IOException {

value = new Double(in.readDouble());

} // end of read method


/**********************************************************************
* method to write this data field 
**********************************************************************/
public void write(BitOutputStream out) throws IOException {

out.writeDouble(value.doubleValue());

} // end of write method


} // end of DoubleField class
