import java.io.*;

public class FloatField extends AbstractDataField {

/**********************************************************************
* constructor 
**********************************************************************/
public FloatField() { this(null, null); }
public FloatField(String name, String comment) {

super(name,32,comment);

/*********************
* min and max values *
*********************/
min_value=null;
max_value=null;

} // end of constructor

/**********************************************************************
* size can't be changed 
**********************************************************************/
public void size(int size) { }


/**********************************************************************
* check if a given Number is a valid value for this field 
**********************************************************************/
public boolean isInValidRange(Number n) {

if(min_value != null && n.floatValue() < min_value.floatValue() ) return false;
if(max_value != null && n.floatValue() > max_value.floatValue() ) return false;

return true;

} // end of isInValidRange method

/**********************************************************************
* return a Number of the appropriate type for this field
* returns null if the data type of this field is unknown or weird.
**********************************************************************/
public Number validateType(Number n) { return new Float(n.floatValue() ); }

/**********************************************************************
* method to read this data field 
**********************************************************************/
public void read(BitInputStream in) throws IOException {

value = new Float(in.readFloat());

} // end of read method


/**********************************************************************
* method to write this data field 
**********************************************************************/
public void write(BitOutputStream out) throws IOException {

out.writeFloat(value.floatValue());

} // end of write method


} // end of FloatField class
