import java.util.*;

public class NullTokenizer extends StringTokenizer {

String delim;

/****************************************************************************
* constructor
****************************************************************************/
NullTokenizer(String string, String delim) {

super(string, delim, true);

this.delim=delim;

} // end of constructor


/****************************************************************************
* return the next token tokens can be empty strings
****************************************************************************/
public String nextToken() throws NoSuchElementException {

//System.out.println("about to read token");
String value = super.nextToken();
//System.out.println("got token value="+value);
if(value.length()==1 && delim.indexOf(value) != -1 ) {
    /***********************************************************
    * got a delimiter - that means this is a zero length field * 
    ***********************************************************/
    return new String();
}

/******************************
* read the trailing delimiter *
******************************/
try { super.nextToken(); }
catch(NoSuchElementException e) {}

return value;

} // end of nextToken method


} // end of NullTokenizer class
