import java.io.*;

public class ReverseFloatField extends FloatField {

/**********************************************************************
* constructor 
**********************************************************************/
public ReverseFloatField() { this(null, null); }
public ReverseFloatField(String name, String comment) { super(name,comment); }


/**********************************************************************
* method to read this data field 
**********************************************************************/
public void read(BitInputStream in) throws IOException {

/*******************************************************
* first read the data into a reversed array of 4 bytes *
*******************************************************/
byte[] bytes = new byte[4];
for(int i=0; i<4; ++i) {
    bytes[3-i] = in.readByte();
}

BitInputStream in2 = new BitInputStream(
                     new ByteArrayInputStream(bytes) );

super.read(in2);
    
} // end of read method


/**********************************************************************
* method to write this data field 
**********************************************************************/
public void write(BitOutputStream out) throws IOException {

ByteArrayOutputStream byte_out = new ByteArrayOutputStream();
BitOutputStream out2 = new BitOutputStream(byte_out);

super.write(out);
byte[] bytes = byte_out.toByteArray();

for(int i=0; i<4; ++i) {
    out.writeByte(bytes[3-i]);
}


} // end of write method


} // end of ReverseFloatField class
