import java.io.*;

/****************************************************************************
* This class represents a little-endian unsigned integer data field
* It's probably not safe to use one of thes with an odd (not a multiple
* of 8) number of bits.
****************************************************************************/
public class ReverseUnsignedIntField extends UnsignedIntField {


/**********************************************************************
* constructor s
**********************************************************************/
public ReverseUnsignedIntField() { super(); }

public ReverseUnsignedIntField(String name, int size, String comment) {
super(name,size,comment);
}


/**********************************************************************
* method to read this data field 
**********************************************************************/
public void read(BitInputStream in) throws IOException {

    /*******************************************
    * read the data the regular big-endian way *
    *******************************************/
    super.read(in);
    byteReverseValue();

} // end of read method 

/**********************************************************************
* method to write this data field 
**********************************************************************/
public void write(BitOutputStream out) throws IOException {

    /*********************************************************************
    * we do two reverses. This isn't the most eficcient thing to do,
    * but it certainly makes coding simpler
    *********************************************************************/
    byteReverseValue();
    super.write(out);
    byteReverseValue();

} // end of write method


} // end of ReverseUnsignedIntField class
