import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.*;

public class SearchDialog extends JDialog 
                          implements ActionListener, ProgressListener {

PacketEditor editor;
JTextField text;
JCheckBox just_window;
JCheckBox from_beginning;

JTextField depth;
JProgressBar progress;

boolean cancel;

/*****************************************************************************
*
*****************************************************************************/
public SearchDialog(PacketEditor editor) {
    super(editor, "Search", false);

    this.editor=editor;
    cancel=false;

    Container pane = getContentPane();
    pane.setLayout(new BoxLayout(pane, BoxLayout.Y_AXIS));
//    pane.setLayout(new GridLayout(6,1));


    JLabel label = new JLabel("Search for...");
    label.setAlignmentX(0.0f);
    pane.add(label);

    text = new JTextField(20);
    text.setAlignmentX(0.0f);
    pane.add(text);

    /**********
    * options *
    **********/
    just_window = new JCheckBox("Just Parsed Window", true);
    just_window.setAlignmentX(0.0f);
    pane.add(just_window);

    from_beginning = new JCheckBox("Search From Beginning", false);
    from_beginning.setAlignmentX(0.0f);
    pane.add(from_beginning);


    JPanel panel = new JPanel();
    panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
    panel.setAlignmentX(0.0f);
    pane.add(panel);

    depth=new JTextField(3);
    depth.setText("100");
    depth.setMaximumSize(depth.getPreferredSize());
    panel.add(depth);
    panel.add(new JLabel(" Search Depth"));

    /***********
    * progress *
    ***********/
    progress = new JProgressBar(0,100);
    progress.setAlignmentX(0.0f);
    pane.add(progress);

    /**********
    * buttons *
    **********/
    JPanel buttons = new JPanel();
    buttons.setAlignmentX(0.0f);
    buttons.setLayout(new GridLayout(1,2));
    getContentPane().add(buttons);

    JButton ok = new JButton("Search");
    ok.addActionListener(this);
    buttons.add(ok);

    JButton cancel = new JButton("Cancel");
    cancel.addActionListener(this);
    buttons.add(cancel);

    JButton dismiss = new JButton("Dismiss");
    dismiss.addActionListener(this);
    buttons.add(dismiss);


    pack();

    

} // end of constructor

/*****************************************************************************
*
*****************************************************************************/
public void actionPerformed(ActionEvent e) {

    String param = e.getActionCommand();

System.out.println("param="+param);

    if(param.equals("Search")) {
        cancel=false;
        editor.search();
    } else if(param.equals("Cancel")) {
        cancel=true;
    } else if(param.equals("Dismiss")) {
        cancel=true;
        dispose();
    }

}

/*****************************************************************************
*
*****************************************************************************/
public String getPattern() { 

    return text.getText(); 
}

/*****************************************************************************
*
*****************************************************************************/
public boolean justWindow() { return just_window.isSelected(); }

/*****************************************************************************
*
*****************************************************************************/
public boolean fromBeginning() {
    return from_beginning.isSelected();
}


/*****************************************************************************
*
*****************************************************************************/
public int getDepth() {

    String string = depth.getText();
    try {
        return Integer.parseInt(string);
    } catch(Exception e) {
        depth.setText("1");
        return 1;
    }

} // end of getDepth method

/*****************************************************************************
*
*****************************************************************************/
public void updateProgress(int percent) {
    progress.setValue(percent);
}

/*****************************************************************************
*
*****************************************************************************/
public void resetProgress() {
    progress.setValue(0);
}


/*****************************************************************************
*
*****************************************************************************/
public boolean cancel() { 

    if(cancel) {
        cancel=false;
        return true;
    } else {
        return false;
    }

}

} // end of SearchDialog method
