import java.io.*;

public class BiffString extends DataBlock {

/*****************************************************************************
*
*****************************************************************************/
public BiffString() throws IOException { super("BiffString"); }


/*****************************************************************************
*
*****************************************************************************/
public void read(BitInputStream in) throws IOException {

/******************
* read the header *
******************/
super.read(in);

int length = get("length").value().intValue();
int type   = get("type" ).value().intValue();

if(type==1) length *= 2;

boolean is_rich = get("rich_text").value().intValue() == 1;
if(is_rich) {
    /******************************************************
    * rich text strings have an additional two byte field *
    ******************************************************/
    AbstractDataField field = new ReverseUnsignedIntField("n_runs", 16,
                                  "Number of rich text runs");
    field.read(in);
    add(field);
}


ASCIIDataField text = new ASCIIDataField("value", 8*length, "string value");
text.read(in);
add(text);

if(is_rich) {
    int nruns = get("n_runs").value().intValue();
    for(int i=0; i<nruns; ++i) {
        DataBlock run = new DataBlock("RichTextRun");
        run.read(in);
        add(run);
    }
}

} // end of read method

/*****************************************************************************
*
*****************************************************************************/
public String toString() {

    return "String: \""+
           ((DataField)get(getChildCount()-1)).formattedValue()+
           "\"";

} // end of toString method

} // end of BiffString class
