import java.io.*;

public class MulBlank extends DataBlock {

int length;

/*****************************************************************************
*
*****************************************************************************/
public MulBlank(int length) throws IOException { 

super("MulBlank"); 

this.length = length;

} // end of constructor


/*****************************************************************************
*
*****************************************************************************/
public void read(BitInputStream in) throws IOException {

/******************
* read the header *
******************/
super.read(in);

int first_col = get("first_col").value().intValue();

int ncol = (length - size()/8 -2)/2;
for(int i=0; i<ncol; ++i) {

    AbstractDataField field = new ReverseUnsignedIntField("xf_index"+i, 16,
                                "index to XF record for col "+(first_col+i) );
    field.read(in);
    add(field);

} 


/******************************
* read the last column number *
******************************/
AbstractDataField last = new ReverseUnsignedIntField("last_col", 16,
                                                     "last blank column" );
last.read(in);
add(last);

} // end of read method

} // end of MulBlank class
