import java.io.*;

public class RKValue extends CompositeDataField {

/*****************************************************************************
*
*****************************************************************************/
public RKValue() throws IOException { super("RKValue"); }

/*****************************************************************************
*
*****************************************************************************/
public boolean isFloat() {

    return get("integer").value().intValue() == 0;
}

/*****************************************************************************
*
*****************************************************************************/
public boolean isPercent() {

    return get("integer").value().intValue() == 1;
}

/**********************************************************************
* accessors 
**********************************************************************/
public Number minValue() {
    if(isFloat()) return null;
    else          return new Integer(Integer.MIN_VALUE);
}

public Number maxValue() {
    if(isFloat()) return null;
    else          return new Integer(Integer.MAX_VALUE);


}

/******************************************************************************
* set (encode) the value
******************************************************************************/
public void   value(Number value) {}

/******************************************************************************
* decode the value
******************************************************************************/
public Number value() {

byte[] bits = new byte[4];

bits[3] = get("bits_5_0"  ).value().byteValue();
bits[2] = get("bits_13_6" ).value().byteValue();
bits[1] = get("bits_21_14").value().byteValue();
bits[0] = get("bits_29_22").value().byteValue();

if(isFloat()) {
    /**********************************
    * this is a floating point number *
    **********************************/
    byte[] data = new byte[8];

    data[0] = bits[0];
    data[1] = bits[1];
    data[2] = bits[2];
    data[3] = (byte)(bits[3] << 2);
    data[4] = 0;
    data[5] = 0;
    data[6] = 0;
    data[7] = 0;

    
    double decoded;
    try {
        DataInputStream in = new DataInputStream(
                             new ByteArrayInputStream(data));
        decoded = in.readDouble();
        in.close();
    } catch(IOException e) { 
        System.err.println(e);
        decoded=Double.NaN;
    }


    if(isPercent()) decoded *= 100.;
    return new Double(decoded);

} else {
    /*********************
    * this is an integer *
    *********************/
    int decoded = bits[0];

    decoded <<=8;
    decoded |= bits[1];


    decoded <<=8;
    decoded |= bits[2];


    decoded <<=6;
    decoded |= (bits[3] << 2);

    if(isPercent() ) decoded *= 100;

    return new Integer(decoded);

} // end if integer

} // end of value get method



} // end of RKValue class
