import java.io.*;

public class SST extends DataBlock {

int items_in_header;

/*****************************************************************************
*
*****************************************************************************/
public SST() throws IOException { super("SST"); }


/*****************************************************************************
* return the number of strings in the table
*****************************************************************************/
public int getStringCount() { return getChildCount() - items_in_header; }


/*****************************************************************************
* return a string in the table with a given index
*****************************************************************************/
public String getString(int index) {

    BiffString s = (BiffString)get(index+items_in_header);
    return s.get("value").formattedValue();
}

/*****************************************************************************
*
*****************************************************************************/
public void read(BitInputStream in) throws IOException {

/******************
* read the header *
******************/
super.read(in);
items_in_header = getChildCount();

int nstrings = get("nstrings").value().intValue();

for(int i=0; i<nstrings; ++i) {

    BiffString string = new BiffString();
    string.read(in);
    add(string);

}

} // end of read method

} // end of SST class
