import java.util.*;
import java.io.*;

class PacketStructure {

/**************************************************************************
***************************************************************************
* Simple embedded class for describing a packet highlight
**************************************************************************/
class Highlight {

Highlight(int header, String name) {

    this.header = header;
    this.name = name;
}

    public int header;
    public String name;

} // end of Highlight embedded class *************************************


/*******
* data *
*******/
private List headers;
private List trailers;
private List highlights;
String description;

/***************************************************************************
* constructor 
***************************************************************************/
PacketStructure() {

headers = new ArrayList();
trailers = new ArrayList();

highlights = new ArrayList();
description = "";

} // end of constructor

/***************************************************************************
* accessors 
***************************************************************************/
public void addHeader( String name) {  headers.add(name); }
public void addTrailer(String name) { trailers.add(name); }

public void   setDescription(String descr ) {        description = descr; }
public String getDescription(             ) { return description; }
 
public void addHighlight(int header, String name) {
    highlights.add(new Highlight(header, name) );
}


/***************************************************************************
* add the headers and trailers to a packet 
***************************************************************************/
public void install(Packet p) throws IOException {

    /******************
    * add the headers *
    ******************/
    for(Iterator it= headers.iterator(); it.hasNext(); ) {
        String name = (String)it.next();

        p.addHeader(new DataBlock(name) );
    }

    /*******************
    * add the trailers *
    *******************/
    for(Iterator it= trailers.iterator(); it.hasNext(); ) {
        String name = (String)it.next();
        p.addTrailer(new DataBlock(name) );
    }

    /*********************
    * set the highlights *
    *********************/
    p.clearHighlights();
    for(Iterator it=highlights.iterator(); it.hasNext(); ) {
        Highlight h = (Highlight)it.next();

        p.addHighlight(h.header, h.name);
    }

    /*****************************
    * set the packet description *
    *****************************/
    p.setDescription(description);
    

} // end install method 
    
} // end of PacketStructure class
