import java.io.*;

public class MP3Stream extends DataStream {

/******************************************************************************
* constructor
******************************************************************************/
public MP3Stream() {

super(new MP3Frame() );


} // end of constructor


    
/****************************************************************************
* read a single "unit" of data from the stream
****************************************************************************/
protected DataNode readUnit(BitInputStream in) throws IOException {

//if(getChildCount()>0) throw new EOFException();


MP3Frame frame = new MP3Frame();
try {
    frame.read(in);
    return frame;
} catch(EOFException e) {
    /****************
    * this is normal *
    *****************/
    throw e; 

} catch(IOException e) {
    if(e.getMessage().equals("Not a Frame") ) {
        /***********************************************
        * it wasn't a Frame, so try reading an end tag *
        ***********************************************/
  //      System.out.println("reading tag");
        DataBlock tag = new DataBlock("MP3Tag");
        tag.read(in);
        return tag;
    } else {
        throw e;
    }
}

} // end of readUnit method



protected void readHeader(BitInputStream in) throws IOException {

/**********************************
* read an ID3 tag if there is one *
**********************************/
try { 
    ID3Tag id3 = new ID3Tag();
    id3.read(in);
    add(id3);
} catch(IOException e) {
    if(e.getMessage()==null || !e.getMessage().equals("Not an ID3 Tag") ) {
        throw e;
    }
}

} // end of readHeader method


} // end of MPEGStream class
