import java.io.*;

public class ExtraBitInfo extends RawDataBlock {

private static final int BLOCK=32;

/**************************************************************************
* constructor
**************************************************************************/
public ExtraBitInfo() { super(BLOCK); }


/**************************************************************************
* pull the data out of the flag bits
**************************************************************************/
public void read(BitInputStream in) throws IOException {

int offset=0;

while(in.readBit()==1) {

    if(offset==size) resize(size+BLOCK);
    data[offset++] = in.readByte();

}

resize(offset);


} // end of read method

/**************************************************************************
* pull the data out of the flag bits
**************************************************************************/
public void write(BitOutputStream out) throws IOException {

for(int i=0; i<size; ++i) {

    out.writeBit(1);
    out.writeByte(data[i]);
}

out.writeBit(0);


} // end of write method



/**************************************************************************
* size in bits including flag bits
**************************************************************************/
public int size() { return 9*size+1; }

/**************************************************************************
* string representation
**************************************************************************/
public String toString() { 
    return "Extra Bit Info ("+size+") bytes";
}

} // end of ExtraBitInfo class
