import java.io.*;

public class Huffman {

public static final int NOT_THERE_YET=-99999;
protected int[][] table;

/*****************************************************************************
*****************************************************************************/
public Huffman() {}

/*****************************************************************************
*****************************************************************************/
public Huffman(int nbits) { allocateTable(nbits); }



/*****************************************************************************
* Allocate memory for the Huffman table with a given maximum number
* bits in the Huffman codes
*****************************************************************************/
protected void allocateTable(int nbits) {

table = new int[nbits][];

int size=2;
for(int length=0; length<nbits; ++length) {

    table[length] = new int[size];

    for(int j=0; j<size; ++j) {
        table[length][j]=NOT_THERE_YET;
    }

    size <<= 1;
}

} // end of allocateTable method


/*****************************************************************************
* read the next Huffman code from the input stream and return its
* decoded value. Returns NOT_THERE_YET on error.
*****************************************************************************/
public int decode(BitInputStream in ) throws IOException {

int code =0;
for(int length=0; length<table.length; ++length) {

    code <<=1;
    code |= in.readBit();

    if(table[length][code] != NOT_THERE_YET) return table[length][code];

} // end of loop over bits

/************************
* we shouldn't get here *
************************/
return NOT_THERE_YET;


} // end of decode method


} // end of Huffman class
