import java.io.*;

/*****************************************************************************
* This class has MPEG-specific Huffman decodeing stuff, like
* factory methods to generate fixed tables.
*****************************************************************************/
public class MPEGHuffman extends Huffman {

public static int MACRO_BLOCK_ESCAPE=35;
public static int MACRO_BLOCK_STUFFING=34;

/*****************************************************************************
*
*****************************************************************************/
public static Huffman makeAddressIncrement() {

Huffman huff = new Huffman(11);

huff.table[0][1]=1;

huff.table[2][2]=3;
huff.table[2][3]=2;

huff.table[3][2]=5;
huff.table[3][3]=4;

huff.table[4][2]=7;
huff.table[4][3]=6;

huff.table[6][6]=9;
huff.table[6][7]=8;

huff.table[7][ 6]=15;
huff.table[7][ 7]=14;
huff.table[7][ 8]=13;
huff.table[7][ 9]=12;
huff.table[7][10]=11;
huff.table[7][11]=10;


huff.table[9][18]=21;
huff.table[9][19]=20;
huff.table[9][20]=19;
huff.table[9][21]=18;
huff.table[9][22]=17;
huff.table[9][23]=16;

huff.table[10][ 8]=MACRO_BLOCK_ESCAPE;
huff.table[10][15]=MACRO_BLOCK_STUFFING;
huff.table[10][24]=33;
huff.table[10][25]=32;
huff.table[10][26]=31;
huff.table[10][27]=30;
huff.table[10][28]=29;
huff.table[10][29]=28;
huff.table[10][30]=27;
huff.table[10][31]=26;
huff.table[10][32]=25;
huff.table[10][33]=24;
huff.table[10][34]=23;
huff.table[10][35]=22;

return huff;

} // end of makeAddressIncrement method

/*****************************************************************************
* intra, pattern, backward, forward, quant 
* 
*****************************************************************************/
public static Huffman makePType() {

Huffman huff = new Huffman(6);

huff.table[0][1]=10;
huff.table[1][1]=8;
huff.table[2][1]=2;
huff.table[4][1]=9;
huff.table[4][2]=11;
huff.table[4][3]=16;
huff.table[5][1]=17;

return huff;
} // end of makePType method

/*****************************************************************************
* intra, pattern, backward, forward, quant 
* 
*****************************************************************************/
public static Huffman makeBType() {

Huffman huff = new Huffman(6);

huff.table[1][2]=6;
huff.table[1][3]=14;
huff.table[2][2]=4;
huff.table[2][3]=12;
huff.table[3][2]=2;
huff.table[3][3]=10;
huff.table[4][2]=15;
huff.table[4][3]=16;
huff.table[5][1]=17;
huff.table[5][2]=13;
huff.table[5][3]=11;

return huff;
} // end of makeBType method

/*****************************************************************************
* Motion Vector codes 
* 
*****************************************************************************/
public static Huffman makeVector() {

Huffman huff = new Huffman(11);

huff.table[7][6]=7;
huff.table[7][7]=-7;

huff.table[9][18]=10;
huff.table[9][19]=-10;
huff.table[9][20]=9;
huff.table[9][21]=-9;
huff.table[9][22]=8;
huff.table[9][23]=-8;

huff.table[10][24]=16;
huff.table[10][25]=-16;
huff.table[10][26]=15;
huff.table[10][27]=-15;
huff.table[10][28]=14;
huff.table[10][29]=-14;
huff.table[10][30]=13;
huff.table[10][31]=-13;
huff.table[10][32]=12;
huff.table[10][33]=-12;
huff.table[10][34]=11;
huff.table[10][35]=-11;

return huff;
} // end of makeVector method

} // end of MPEGHuffman
