import java.io.*;

public class MacroBlock extends DataBlock {

int type;

/****************************************************************************
*
****************************************************************************/
public MacroBlock(int type) { this.type=type; }

/****************************************************************************
*
****************************************************************************/
public void read(BitInputStream in ) throws IOException {

/***************************
* decode address increment *
***************************/
Huffman huff = MPEGHuffman.makeAddressIncrement();

int address=0;
int increment=0;
do {
    increment = huff.decode(in);
System.out.println("increment="+increment);
    if(increment== MPEGHuffman.MACRO_BLOCK_ESCAPE) {
        address+= 33;
        increment=MPEGHuffman.MACRO_BLOCK_STUFFING;
    }
} while(increment==MPEGHuffman.MACRO_BLOCK_STUFFING);

address += increment;

System.out.println("address="+address+"\n");


/*************************
* decode macroblock type *
*************************/
boolean intra;
boolean pattern;
boolean motion_forward;
boolean motion_backward;
boolean quant;

if(type == 1) {
    /*********
    * I type *
    *********/
    motion_forward=false;
    motion_backward=false;
    pattern=false;
    intra=true;

    int bit = in.readBit();
    if(bit==1) quant=true;
    else {
        quant=flase;
        in.readBit();
    }
} else if(type==2){
    /*********
    * P type *
    *********/
    huff = MPEGHuffman.makePType();
    int value = huff.decode(in);
    intra           = (value & 16) != 0;
    pattern         = (value &  8) != 0;
    motion_backward = (value &  4) != 0;
    motion_forward  = (value &  2) != 0;
    quant           = (value &  1) != 0;

} else {
    /*********
    * B type *
    *********/

    huff = MPEGHuffman.makeBType();
    int value = huff.decode(in);
    intra           = (value & 16) != 0;
    pattern         = (value &  8) != 0;
    motion_backward = (value &  4) != 0;
    motion_forward  = (value &  2) != 0;
    quant           = (value &  1) != 0;

}

System.out.println( "intra="+intra+
                   " pattern="+pattern+
                   " forward="+motion_forward+
                   " backward="+motion_backward+
                   " quant="+quant;

/***************
* quantization *
***************/
int quant_scale=0;
if(quant) quant_scale = in.readBits(5);
System.out.println("quant_scale="+quant_scale);

/************************************
* motion vectors *
************************************/
if(motion_forward) {
    /*************
    * horizontal *
    *************/
    





    
    



} // end of read method

/****************************************************************************
*
****************************************************************************/
public String toString() { return "MacroBlock"; }

} // end of MacroBlock class
