import java.io.*;

public class SEPX extends DataBlock {


/****************************************************************************
*
****************************************************************************/
public void read(BitInputStream in ) throws IOException {

AbstractDataField field = new UnsignedIntField("length",16,
                                               "Length of data area");
field.read(in);
add(field);

int length = field.value().intValue();

/*****************************************************************
* read the sprm data. We first read the raw data to an array
* so that we can be sure we don't get out of synch
*****************************************************************/
byte[] data = new byte[length];
in.readFully(data);

BitInputStream in2 = new BitInputStream(new ByteArrayInputStream(data));

try {
    while(in2.available()>0) {

        Sprm sprm = new Sprm();
        sprm.read(in);
        add(sprm);

    }
} catch(EOFException e) { 
    throw new IOException("Uneven number of sprms in CHPX");
}
    

} // end of read method


/****************************************************************************
*
****************************************************************************/
public String toString() { return "Section Property Exceptions"; }

} // end of Sprm class
