import java.io.*;

public class Sprm extends DataBlock {

/****************************************************************************
*
****************************************************************************/
public Sprm() throws IOException { super("sprm"); }


/****************************************************************************
* get the unique identifier for this sprm
****************************************************************************/
public int getID() {

int hi = get("id_hi").value().intValue();
int lo = get("id_lo").value().intValue();

int id = ( (hi << 8) | lo );

return id;

} // end of getID method



/****************************************************************************
*
****************************************************************************/
public void read(BitInputStream in ) throws IOException {

/******************
* read the header *
******************/
super.read(in);

/***********************
* optional length byte *
***********************/
int spra = get("spra").value().intValue();
int length;
if(     spra == 0 || spra == 1             ) length=1;
else if(spra == 2 || spra == 4 || spra == 5) length=2;
else if(spra == 7                          ) length=3;
else if(spra == 3                          ) length=4;
else {
    /******************
    * variable length *
    ******************/
    AbstractDataField field = new UnsignedIntField("length",8,
                                                   "Length of data area");
    field.read(in);
    add(field);
    length = field.value().intValue();
}

/*************
* data field *
*************/
RawDataBlock raw = new RawDataBlock(length);
raw.read(in);
add(raw);


    

} // end of read method


/****************************************************************************
*
****************************************************************************/
public String toString() { return "sprm id="+getID(); }

} // end of Sprm class
