import java.io.*;

public class Block0 extends DataBlock {

DataBlock head;
DataBlock bbd_list;
int n_bbd;

/****************************************************************************
* for a given block number returns the placement of that block in the
* big block depot, or -1 if it is not part of the BBD
****************************************************************************/
public int bigBlockDepotIndex(int index) {

for(int i=0; i<bbd_list.getChildCount(); ++i) {


    DataField field = (DataField)bbd_list.get(i);
//System.out.println("index="+index+" table="+field.value().intValue() );

    if(index == field.value().intValue() ) return i;
}

return -1;

} // end of isBBDBlock method

/****************************************************************************
*
****************************************************************************/
public int getBigBlockDepotCount() { return n_bbd; }

/****************************************************************************
*
****************************************************************************/
public int getRootStartBlock() { 
    return head.get("root_start").value().intValue(); 
}

/****************************************************************************
*
****************************************************************************/
public int getSmallBlockDepotStartBlock() { 
    return head.get("sbd_start").value().intValue(); 
}



/****************************************************************************
*
****************************************************************************/
public void read(BitInputStream in) throws IOException {

head = new DataBlock("Header");
head.read(in);
add(head);

bbd_list = new DataBlock();
bbd_list.name("Big Block Depot List");
add(bbd_list);

n_bbd = head.get("n_bbd").value().intValue();
for(int i=0; i<n_bbd; ++i) {

    AbstractDataField field = new ReverseSignedIntField("block"+i, 32,
                                  "big block depot block number" );
    field.read(in);
    bbd_list.add(field);

}

int remaining = 512 - size()/8;

RawDataBlock raw = new RawDataBlock(remaining);
raw.read(in);
add(raw);


} // end of read method

/****************************************************************************
*
****************************************************************************/
public String toString() { return "Block 0"; }


} // end of Constant class
