/******************************************************************************
* This is an abstract class to handle big and small block depots
* Those two subclasses differ in the way in which they are read.
*
* A "Depot" (a term presumably coined by Perl Laola/OLE author Martin Schwartz
* is an array of pointers linking a bunch of blocks together as a linked 
* list. 
******************************************************************************/

public abstract class Depot {

protected int[] places;

/****************************************************************************
*
****************************************************************************/
public Depot(int nblocks) {

places = new int[nblocks*128];

} // end of constructor


/****************************************************************************
*
****************************************************************************/
public int nextBlock(int last_block) {

    return places[last_block];
}



} // end of Depot class
