import java.io.*;

public class Property extends DataBlock {

/****************************************************************************
*
****************************************************************************/
public Property() throws IOException { super("Property"); }

/****************************************************************************
*
****************************************************************************/
public String getType() {

    int type = get("type").value().intValue();
    if(type==1) return "DIRECTORY";
    else if(type==2) return "FILE";
    else if(type==5) return "ROOT";
    else return "UNKNOWN";

} // end of getType method

/****************************************************************************
* returns the name of the property with all "\0"'s removed.
* Funny, but I can't seem to get Java to read Unicode, so this is a cludge
* This method also strips off trailing padding
****************************************************************************/
public String getName() {

String name =  get("name").formattedValue();
StringBuffer buffer = new StringBuffer();

for(int i=0; i<name.length(); ++i) {

    char c = name.charAt(i);
    if(c != '\0') buffer.append(c);

}

return buffer.toString();

} // end of getName method


/****************************************************************************
* Returns true if this is a directory or the root property
****************************************************************************/
public boolean isDirectory() {

    int type = get("type").value().intValue();
    return type==1 || type ==5;

} // end of isDirectory method

/****************************************************************************
* Returns true if this is the root property
****************************************************************************/
public boolean isRoot() {

    int type = get("type").value().intValue();
    return type ==5;

} // end of isRoot method



} // end of Property class
