import java.io.*;

/****************************************************************************
*
* This is a class for extrafting the contenmts of an LDP from a stream of
* CCSDS packets.
*
****************************************************************************/
public class LDPFilter extends Filter {

int data_block_index;
Packet packet;

/****************************************************************************
*
****************************************************************************/
public LDPFilter(BitInputStream in) throws IOException {

super(in);


/********************
* create the packet *
********************/
packet = new Packet();

packet.addHeader(new DataBlock("SwiftHead2"));
packet.addHeader(new DataBlock("LDPHead3")  );

data_block_index = packet.getChildCount();

packet.addTrailer(new DataBlock("LDPTrailer"));


start();

} // end of LDPFilter method


/****************************************************************************
* Subclasses must define this method to read some part of the input stream
* and write the decoded data to the output stream.
* This method will be called repeatedly until the data have been decoded.
****************************************************************************/
protected void decode(BitInputStream in, OutputStream out) throws IOException {


packet.read(in);

RawDataBlock data = (RawDataBlock)packet.get(data_block_index);

out.write(data.getByteArray());


} // end of decode method

/****************************************************************************
* for testing
****************************************************************************/
public static void main(String[] args) throws Exception {

LDPFilter filter = new LDPFilter(
                   new BitInputStream(
                   new FileInputStream("z.tmp")));



} 

} // end of LDPFilter method
